# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 匿名登录，加购1件重量待核验商品，无法结算
# @Date:: 2024/11/22
import unittest,allure,time,pytest
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from YiMao.data.WuShangSceneTestData import *


DescName = "Anon019-匿名登录，加购1件重量待核验商品，无法结算"
@allure.story(f'[场景测试] {DescName}验证')
class Test_CAnon019(unittest.TestCase):
    f'''@Date:: 2024/11/15
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''
    def setUp(self) -> None:
        self.timestamp = int(time.time())
        self.ymc = YMClientApi(ShoppingCartMac)
        self.piece_rate_goods = PieceRateGoods["GoodsInputcode"]

    def test_CAnon019(self):
        allure.dynamic.description(f"描述：{DescName}\n")
        allure.step("步骤1：session开始")
        self.ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = self.ymc.login_app_v2(Payload01)
        allure.step("步骤3：获取商品信息")
        GetGoodsInfoResp_01 = self.ymc.get_goods_info(self.piece_rate_goods)
        if GetGoodsInfoResp_01['msg'] != '加购商品不存在':
            allure.step("步骤4：添加会员有优惠商品")
            AddGoodsResp = self.ymc.add_cart_goods(GetGoodsInfoResp_01, 1, LoginData)

            # allure.step("\n步骤5：退购一件商品")
            # GetGoodsInfoList = [GetGoodsInfoResp_01]
            # self.ymc.delete_cart_goods(GetGoodsInfoList, LoginData, AddGoodsResp)

            allure.step("步骤6：获取购物车商品信息")
            LOGGER.info(f"---获取购物车商品信息-1")
            self.ymc.get_cart_goods_info([GetGoodsInfoResp_01])
            allure.step("步骤7：请求订单结算")
            LOGGER.info(f"---请求订单结算-1")
            self.ymc.request_order_settlement(LoginData)

            allure.step("步骤8：核验商品")
            self.ymc.verify_the_goods_through_verification()

            allure.step("步骤6：获取购物车商品信息")
            LOGGER.info(f"---获取购物车商品信息-2")
            self.ymc.get_cart_goods_info([GetGoodsInfoResp_01])
            allure.step("步骤7：请求订单结算")
            LOGGER.info(f"---请求订单结算-2")
            self.ymc.request_order_settlement(LoginData)

        else:
            LOGGER.info(f"---商品 {PieceRateGoods} 不存在")
            pytest.fail(f"---商品 {PieceRateGoods} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)