# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Date:: 2024/11/18-9:38
# @Description::
import unittest,allure,time,pytest,ddt
from configs.globalParams import DataInit
from YiMao.businessFunc.ClientApiLib import YMClientApi
DescName = "Anon001-非会员加购购物袋并试算"

@ddt.ddt
class Test_CAnon001_AddShoppingBagAndSettlePayment(unittest.TestCase):
    f'''@Date:: 2024/11/15
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''

    @ddt.data(*DataInit)
    def test_CAnon00101_AddMidShoppingbagsForPurchase(self, data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])
        goodsbag_mid = data["ShoppingBag"]["mid"]

        allure.step("步骤1：session开始")
        ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = ymc.login_app_v2(Payload01)
        allure.step("步骤3：获取商品信息")
        GoodsInfoData = ymc.get_goods_info(goodsbag_mid)
        if GoodsInfoData['msg'] != '加购商品不存在':
            allure.step("步骤4：添加购物袋")
            ymc.add_cart_goods(GoodsInfoData, 2, LoginData)
            allure.step("步骤5：获取购物车商品信息")
            ymc.get_cart_goods_info([GoodsInfoData])
            allure.step("步骤6：请求订单结算")
            ymc.request_order_settlement(LoginData)
        else:
            pytest.fail(f"购物袋 {goodsbag_mid} 不存在")

    @ddt.data(*DataInit)
    def test_CAnon00102_AddMaxShoppingbagsForPurchase(self, data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])
        goodsbag_max = data["ShoppingBag"]["max"]

        allure.step("步骤1：session开始")
        ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = ymc.login_app_v2(Payload01)
        allure.step("步骤3：获取商品信息")
        GoodsInfoData = ymc.get_goods_info(goodsbag_max)
        if GoodsInfoData['msg'] != '加购商品不存在':
            allure.step("步骤4：添加购物袋")
            ymc.add_cart_goods(GoodsInfoData, 2, LoginData)
            allure.step("步骤5：获取购物车商品信息")
            ymc.get_cart_goods_info([GoodsInfoData])
            allure.step("步骤6：请求订单结算")
            ymc.request_order_settlement(LoginData)
        else:
            pytest.fail(f"购物袋 {goodsbag_max} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)