# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 游客登录，加购2个会员商品，退购一个，并结算
# @Date:: 2024/11/20
import unittest,allure,time,pytest,ddt
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from configs.globalParams import DataInit
DescName = "Anon010-非会员，加购2个会员商品，退购一个，并结算"

@ddt.ddt
class Test_CAnon010(unittest.TestCase):
    f'''@Date:: 2024/11/20
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''
    @ddt.data(*DataInit)
    def test_CAnon010_ReturnOfMemberProducts(self, data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])
        vip_goods_01 = data["VipGoods"]["goods01"]
        vip_goods_02 = data["VipGoods"]["goods02"]

        allure.step("步骤1：session开始")
        ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = ymc.login_app_v2(Payload01)
        '''step1：加购商品x，分别加购x件'''
        allure.step("步骤3：获取商品1信息")
        GetGoodsInfoResp_01 = ymc.get_goods_info(InputCode=vip_goods_01)
        if GetGoodsInfoResp_01['msg'] != '加购商品不存在':
            allure.step("步骤4：添加商品1")
            add_goods_dict = {}
            AddGoodsResp_01 = ymc.add_cart_goods(GetGoodsInfoResp_01, 2, LoginData)
            add_goods_dict[AddGoodsResp_01["data"]["orderItemList"][0]["inputCode"]] = AddGoodsResp_01["data"]["orderItemList"][0]["qty"]

            allure.step("步骤5：获取商品2信息")
            GetGoodsInfoResp_02 = ymc.get_goods_info(InputCode=vip_goods_02)
            if GetGoodsInfoResp_02['msg'] != '加购商品不存在':
                allure.step("步骤6：添加商品2")
                AddGoodsResp_02 = ymc.add_cart_goods(GetGoodsInfoResp_02, 1, LoginData)
                add_goods_dict[AddGoodsResp_02["data"]["orderItemList"][0]["inputCode"]] = AddGoodsResp_02["data"]["orderItemList"][0]["qty"]
                LOGGER.info(f"---添加的商品Inputcode和数量为：{add_goods_dict}\n")

                ''' step2：随机退购一个商品，并结算 '''
                allure.step("\n步骤7：退购一件商品")
                GetGoodsInfoList = [GetGoodsInfoResp_01, GetGoodsInfoResp_02]
                AddGoodsResp_List = [AddGoodsResp_01, AddGoodsResp_02]
                delpayload = ymc.delete_cart_goods(GetGoodsInfoList, LoginData, AddGoodsResp_List)
                delgoods_dict = {}
                delgoods_dict[delpayload['deleteGoods'][0]['inputCode']] = delpayload['deleteGoods'][0]['qty']
                LOGGER.info(f"---退购商品Inputcode和数量为：{delgoods_dict}\n")

                # 刷新购物车商品数量：GoodsInfoData["data"]["qty"]
                AddGoodsInfoAfterDel = {}
                for k,v in add_goods_dict.items():
                    for k2,v2 in delgoods_dict.items():
                        if k == k2:
                            AddGoodsInfoAfterDel[k] = v - v2
                LOGGER.info(f"---退购商品后，剩余商品及其数量为：{AddGoodsInfoAfterDel}\n")

                last_cart_goods_info = []
                cart_goods_info = [GetGoodsInfoResp_01, GetGoodsInfoResp_02]
                for goods_info in cart_goods_info:
                    if goods_info['data']['inputCode'] in AddGoodsInfoAfterDel.keys():
                        goods_info['data']['qty'] = AddGoodsInfoAfterDel[goods_info['data']['inputCode']]
                        if goods_info['data']['qty'] != 0:
                            last_cart_goods_info.append(goods_info)
                    else:
                        last_cart_goods_info.append(goods_info)
                allure.step("步骤8：获取购物车商品信息")
                ymc.get_cart_goods_info(last_cart_goods_info)
                allure.step("步骤9：请求订单结算")
                ymc.request_order_settlement(LoginData)
            else:
                pytest.fail(f"---商品 {vip_goods_02} 不存在")
        else:
            pytest.fail(f"---商品 {vip_goods_01} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)