# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 游客登录，加购2个重量放通商品，退购一个，并结算
# @Date:: 2024/11/20
import unittest,allure,time,pytest,ddt
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from YiMao.businessFunc.ServiceApiLib import YMServiceApi
from configs.globalParams import DataInit
DescName = "Anon014-非会员加购2个重量放通商品，退购一个"

@ddt.ddt
class Test_CAnon014(unittest.TestCase):
    f'''@Date:: 2024/11/20
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''
    @ddt.data(*DataInit)
    def test_CAnon014_ReturnWeightOfTheProducte(self,data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])
        yms = YMServiceApi()
        weight_to_whitelist_goods = data["WeightToWhitelistGoods"]
        market_and_store_info = {
            "MarketId": data["MarketAndStoreDetails"]["putMarketId"],
            "StoreId": data["MarketAndStoreDetails"]["putStoreId"][0]
        }

        allure.step("[前置条件]：先调用管理平台接口，将指定商品添加到重量放通白名单中")
        pre_respomse = yms.add_weight_to_whitelist(
            weight_to_whitelist_goods, market_and_store_info
        )
        if pre_respomse['data'] is not None:
            LOGGER.info(f"---商品 {weight_to_whitelist_goods['GoodsInputcode']} "
                        f"已添加到重量放通白名单中")
            ''' 2-再调用客户端接口，执行加购操作 '''
            allure.step("[业务步骤]：再调用客户端接口，执行加购操作")
            allure.step("步骤1：session开始")
            ymc.session_start()
            allure.step("步骤2：匿名登录")
            Payload01 = {"action": 0, "isAnon": True}
            LoginData = ymc.login_app_v2(Payload01)

            allure.step("步骤3：获取重量放通白名单商品信息")
            GoodsInfoData1 = ymc.get_goods_info(weight_to_whitelist_goods["GoodsInputcode"])
            LOGGER.info(f"---获取的商品信息为：{GoodsInfoData1}")
            if GoodsInfoData1['data']['weight'] == 0:
                GoodsInfoData1['data']['weight'] = 400
            if GoodsInfoData1['msg'] != '加购商品不存在':
                allure.step("步骤4：加购白名单商品")
                AddGoodsResp = ymc.add_cart_goods(GoodsInfoData1, 1, LoginData)
                LOGGER.info(f"---加购商品返回结果：{AddGoodsResp}")

                ''' step2：随机退购一个商品，并结算 '''
                allure.step("\n步骤5：退购一件商品")
                GetGoodsInfoList = [GoodsInfoData1]
                AddGoodsResp_List = [AddGoodsResp]
                ymc.delete_cart_goods(GetGoodsInfoList, LoginData, AddGoodsResp_List)

                allure.step("步骤6：获取购物车商品信息")
                ymc.get_cart_goods_info([GoodsInfoData1])
                allure.step("步骤7：请求订单结算")
                ymc.request_order_settlement(LoginData)
                allure.step("[后置处理]：删除添加的重量放通白名单商品")
                yms.delete_weight_whitelist_goods()
            else:
                allure.step("[后置处理]：删除添加的重量放通白名单商品")
                yms.delete_weight_whitelist_goods()
                pytest.fail(f"---商品 {weight_to_whitelist_goods['GoodsInputcode']} 不存在")
        else:
            pytest.fail(f"---添加商品 {weight_to_whitelist_goods['GoodsInputcode']} "
                            f"到重量放通白名单失败")
if __name__ == '__main__':
    unittest.main(verbosity=2)