# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 匿名登录,加购计件商品，并退购
# @Date:: 2024/11/22
import unittest,allure,time,pytest,ddt
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from configs.globalParams import DataInit
DescName = "Anon016-匿名登录,加购计件商品，并退购"

@ddt.ddt
class Test_CAnon016(unittest.TestCase):
    f'''@Date:: 2024/11/22
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''

    @ddt.data(*DataInit)
    def test_CAnon016(self,data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])
        piece_rate_goods = data["PieceRateGoods"]["GoodsInputcode"]
        if piece_rate_goods is not None:
            allure.step("步骤1：session开始")
            ymc.session_start()
            allure.step("步骤2：匿名登录")
            Payload01 = {"action": 0, "isAnon": True}
            LoginData = ymc.login_app_v2(Payload01)
            allure.step("步骤3：获取商品信息")
            GetGoodsInfoResp_01 = ymc.get_goods_info(piece_rate_goods)
            if GetGoodsInfoResp_01['msg'] != '加购商品不存在':
                allure.step("步骤4：添加会员有优惠商品")
                AddGoodsResp = ymc.add_cart_goods(GetGoodsInfoResp_01, 2, LoginData)

                allure.step("\n步骤7：退购一件商品")
                GetGoodsInfoList = [GetGoodsInfoResp_01]
                AddGoodsResp_List = [AddGoodsResp]
                ymc.delete_cart_goods(GetGoodsInfoList, LoginData, AddGoodsResp_List)

                allure.step("步骤5：获取购物车商品信息")
                ymc.get_cart_goods_info()
                allure.step("步骤6：请求订单结算")
                ymc.request_order_settlement(LoginData)
            else:
                pytest.fail(f"---商品 {data["PieceRateGoods"]} 不存在")
        else:
            pytest.skip("---该商超未提供 计件商品 该场景跳过测试")


if __name__ == '__main__':
    unittest.main(verbosity=2)