# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Date:: 2024/11/15-14:43
# @Description::
import unittest,allure,time,pytest,ddt
from configs.globalObj import LOGGER
from YiMao.businessFunc.ClientApiLib import YMClientApi
from configs.globalParams import DataInit
DescName = "NoLogin001-购物车客户端-广告"

@ddt.ddt
class Test_CNoLogin001(unittest.TestCase):
    f'''@Date:: 2024/11/15
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''
    @ddt.data(*DataInit)
    def test_CNoLogin001_CheckADs(self,data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])

        AdListData = ymc.get_ads_list()
        if AdListData['data'] != []:
            if "error_msg" not in AdListData:
                adIdList = []
                for ad in AdListData['data']:
                    adIdList.append(ad['id'])
                LOGGER.info(f"---adIdList: {adIdList}---\n")
                for adId in adIdList:
                    ymc.query_ad_detail(str(adId))
        else:
            pytest.fail(f"---该商超未配置广告---\n")

if __name__ == '__main__':
    unittest.main(verbosity=2)