# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 游客转会员登录，加购多件商品，退购一个商品，并结算
# @Date:: 2024/11/21
import unittest,allure,time,pytest,ddt
from YiMao.businessFunc.ClientApiLib import YMClientApi
from configs.globalParams import DataInit
DescName = "Vip011-游客转会员登录，加购多件商品，退购一个商品，并结算"

@ddt.ddt
class Test_CVip011(unittest.TestCase):
    f'''@Date:: 2024/11/20
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''

    @ddt.data(*DataInit)
    def test_CVip011_ReturnOneItemFromMultiplePurchases(self,data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])
        vip_phone_num = data["VIPPhoneNumber"]
        goods_inputcode1 = data["NormalGoods"]['goods01']
        goods_inputcode2 = data["NormalGoods"]['goods02']

        allure.step("步骤1：session开始")
        ymc.session_start()
        allure.step("步骤2：匿名登录")
        Payload01 = {"action": 0, "isAnon": True}
        LoginData = ymc.login_app_v2(Payload01)

        allure.step("步骤3：切换会员登录")
        Payload02 = {"action": 1, "code": vip_phone_num, "isAnon": False}
        ymc.login_app_v2(Payload02)

        '''step1：加购商品x，分别加购x件'''
        allure.step("步骤3：获取商品1信息")
        GetGoodsInfoResp_01 = ymc.get_goods_info(InputCode=goods_inputcode1)
        if GetGoodsInfoResp_01['msg'] != '加购商品不存在':
            allure.step("步骤4：添加商品1")
            ymc.add_cart_goods(GetGoodsInfoResp_01, 2, LoginData)
            allure.step("步骤5：获取商品2信息")
            GetGoodsInfoResp_02 = ymc.get_goods_info(InputCode=goods_inputcode2)
            if GetGoodsInfoResp_02['msg'] != '加购商品不存在':
                allure.step("步骤6：添加商品2")
                AddGoodsResp = ymc.add_cart_goods(GetGoodsInfoResp_02, 2, LoginData)

                ''' step2：随机退购一个商品，并结算 '''
                allure.step("\n步骤7：退购一件商品")
                GetGoodsInfoList = [GetGoodsInfoResp_01, GetGoodsInfoResp_02]
                ymc.delete_cart_goods(GetGoodsInfoList, LoginData, [AddGoodsResp])

                allure.step("步骤8：获取购物车商品信息")
                ymc.get_cart_goods_info([GetGoodsInfoResp_01, GetGoodsInfoResp_02])
                allure.step("步骤9：请求订单结算")
                ymc.request_order_settlement(LoginData)
            else:
                pytest.fail(f"---商品 {goods_inputcode2} 不存在")
        else:
            pytest.fail(f"---商品 {goods_inputcode1} 不存在")


if __name__ == '__main__':
    unittest.main(verbosity=2)