# !/usr/bin/python
# -*- coding: utf-8 -*-
# @Author:: Arthur Wu
# @Description:: 匿名转会员登录，加购计重商品，并结算
# @Date:: 2024/11/22
import unittest,allure,time,pytest,ddt
from YiMao.businessFunc.ClientApiLib import YMClientApi
from configs.globalParams import DataInit
DescName = "Vip017-匿名转会员登录，加购计重商品，并结算"

@ddt.ddt
class Test_CVip017(unittest.TestCase):
    f'''@Date:: 2024/11/22
    @Author:: Arthur Wu
    @Desc::
    [购物车客户端] {DescName}
    '''

    @ddt.data(*DataInit)
    def test_CVip017(self,data):
        allure.dynamic.story(f'[{data['MarketName']}-场景测试] {DescName}验证')
        allure.dynamic.description(f"描述：{data['MarketName']}-{DescName}\n")
        ymc = YMClientApi(data["ShoppingCartMac"])
        vip_phone_num = data["VIPPhoneNumber"]
        bulk_goods = data["MisspellingWeightGoods"]["GoodsInputcode"]
        if bulk_goods is not None:
            allure.step("步骤1：session开始")
            ymc.session_start()
            allure.step("步骤2：匿名登录")
            Payload01 = {"action": 0, "isAnon": True}
            LoginData = ymc.login_app_v2(Payload01)

            allure.step("步骤3：切换会员登录")
            Payload02 = {"action": 1, "code": vip_phone_num, "isAnon": False}
            ymc.login_app_v2(Payload02)

            allure.step("步骤3：获取商品信息")
            GetGoodsInfoResp_01 = ymc.get_goods_info(bulk_goods)
            if GetGoodsInfoResp_01['msg'] != '加购商品不存在':
                allure.step("步骤4：添加会员有优惠商品")
                ymc.add_cart_goods(GetGoodsInfoResp_01, 1, LoginData)
                allure.step("步骤5：获取购物车商品信息")
                ymc.get_cart_goods_info([GetGoodsInfoResp_01])
                allure.step("步骤6：请求订单结算")
                ymc.request_order_settlement(LoginData)
            else:
                pytest.fail(f"---商品 {bulk_goods} 不存在")
        else:
            pytest.skip(f"---{data['MarketName']} 计重商品未提供，跳过该场景测试")


if __name__ == '__main__':
    unittest.main(verbosity=2)
